SystemOrganization addCategory: #GODCall!

GODData subclass: #CallConference
	instanceVariableNames: 'name acronym categories url importantDates venue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!CallConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
acronym
	^ acronym! !

!CallConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
acronym: conferenceAcronym
	acronym := conferenceAcronym! !

!CallConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
categories
	^ categories! !

!CallConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
categories: conferenceCategories
	categories := conferenceCategories! !

!CallConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
importantDates
	 ^ importantDates! !

!CallConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
importantDates: conferenceImportantDates
	importantDates := conferenceImportantDates! !

!CallConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
name
	^ name! !

!CallConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
name: conferenceName
	name := conferenceName! !

!CallConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
venue
	 ^ venue! !

!CallConference methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 21:23'!
venue: conferenceVenue
	venue := conferenceVenue! !

Object subclass: #CallImportantDates
	instanceVariableNames: 'startDate endDate deadlineDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!CallImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:21'!
deadlineDate
	^ deadlineDate! !

!CallImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:22'!
deadlineDate: conferenceDeadlineDate
	deadlineDate := conferenceDeadlineDate! !

!CallImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:19'!
endDate
	^ endDate! !

!CallImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:19'!
endDate: conferenceEndDate
	endDate := conferenceEndDate! !

!CallImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:18'!
startDate
	^ startDate! !

!CallImportantDates methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:19'!
startDate: conferenceStartDate
	startDate := conferenceStartDate! !

Object subclass: #CallVenue
	instanceVariableNames: 'place city country'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!CallVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
city
	^ city! !

!CallVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
city: conferenceCity
	city := conferenceCity! !

!CallVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
country
	^ country! !

!CallVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
country: conferenceCountry
	country := conferenceCountry! !

!CallVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:25'!
place
	^ place! !

!CallVenue methodsFor: 'accessing' stamp: 'pfsm 9/27/2014 12:26'!
place: conferencePlace
	place := conferencePlace! !

Object subclass: #GODCall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GODCall methodsFor: 'initialization' stamp: 'cms 9/27/2014 23:06'!
crawlConferences
	" search for conferences in web, merge information with quallis, and save in database"
	| sourcesCollection urlCollection page spreadsheetCollection spreadsheet mergedSpreadsheet|
	sourcesCollection := self getSources.
     
     	sourcesCollection do: [ :source |
   		urlCollection := self getUrlsFrom: source.
	      urlCollection do: [ :url |
			"page = GODWebPageFetcher getUrl: url.
			godConferenceCollection := GODCallProcessor toConferenceFrom: page withSource: source.
			 spreadsheet = GODOutputSpreadsheet generateSpreadsheetFrom: godConferenceCollection."
			spreadsheetCollection add: spreadsheet.
		].		
     	].

	spreadsheet =  self getQuallisFileAsSpreadsheet.
 	"mergedSpreadsheet = GODProcessor  mergeSpreadsheets: spreadsheetCollection.
      
	godConferenceCollection = GODCallProcessor generateGodConferencesFrom: mergedSpreadsheet.
	GODDBInput save: godConferenceCollection."
     ^ True.     
	! !

!GODCall methodsFor: 'initialization' stamp: 'cms 9/27/2014 23:04'!
getQuallisFileAsSpreadsheet
	"comment stating purpose of message"

	 ^ nil.! !

!GODCall methodsFor: 'initialization' stamp: 'cms 9/27/2014 23:01'!
getSources
	"comment stating purpose of message"

	  ^ nil.! !

!GODCall methodsFor: 'initialization' stamp: 'cms 9/27/2014 23:03'!
getUrlsFrom: source
	"get urls from source, one source example is ConfSearch"

	^ nil.! !

!GODCall methodsFor: 'as yet unclassified' stamp: 'pfsm 9/27/2014 21:38'!
godCallIndexPage
	"generates the index page of GODs Call app"
	^ self subclassResponsibility! !

!GODCall methodsFor: 'as yet unclassified' stamp: 'cms 9/27/2014 22:02'!
submitForm: searchFilter
	"executes a user's query defined in the searchFilter and returns web page"
	|godConferenceCollection godSpreadsheet resultPage|
      "We still don't have theses classes so we left the flow commented "

	"godConferenceCollection :=  GODDBInput getConferences.

      godConferenceCollection := GODConferenceFilter filter: godConferenceCollection with: searchFilter.

      godSpreadsheet := GODSpreadsheetOutput generateSpreadsheetFrom: godConferenceCollection.
     
	resultPage := GODWebGenerator generateSpreadsheetPageFrom: godSpreadsheet."
     ^ resultPage. ! !

Object subclass: #GODCallProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODCall'!

!GODCallProcessor methodsFor: 'as yet unclassified' stamp: 'cms 9/27/2014 23:07'!
generateGodConferencesFrom: spreadsheet
	"comment stating purpose of message"
	^ nil.! !

!GODCallProcessor methodsFor: 'as yet unclassified' stamp: 'cms 9/27/2014 23:06'!
toConferenceFrom: page withSource: source
	 ^ nil.! !
